/* This is a replacement for cygwin's getpwuid function */
/* The standard cygwin (and Unix) versions look for /etc/passwd */
/* I'd like to just look in the present working directory */
#include <stdio.h>
#include <sys/types.h>
#include <pwd.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "rob_getpwuid.h"

static struct passwd pw_passwd;  	/* password structure */
static FILE *passwd_fp; 
static char logname[8];
static char password[1024];
static char gecos[1024];
static char dir[1024];
static char shell[1024];

struct passwd *
rob_getpwuid (uid_t uid)
{
  FILE *fp;
  char buf[1024];

  /* try local ./passwd first, then /etc/passwd */

  if ((fp = fopen ("passwd", "r")) == NULL)
     if ((fp = fopen ("/etc/passwd", "r")) == NULL) 
       {
       return NULL;
       }

  while (fgets (buf, sizeof (buf), fp))
    {
      sscanf (buf, "%[^:]:%[^:]:%d:%d:%[^:]:%[^:]:%s\n",
	      logname, password, &pw_passwd.pw_uid,
             &pw_passwd.pw_gid, gecos,
	      dir, shell);
      pw_passwd.pw_name = logname;
      pw_passwd.pw_passwd = password;
      pw_passwd.pw_comment = "";
      pw_passwd.pw_gecos = gecos;
      pw_passwd.pw_dir = dir;
      pw_passwd.pw_shell = shell;

      if (uid == pw_passwd.pw_uid)
	{
	  fclose (fp);
	  return &pw_passwd;
	}
    }
  fclose (fp);
  return NULL;
}
